<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_contentFilter_compare extends JPlugin
{
	function plgJoomsuite_contentFilter_compare( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onFilterWhere(&$where, $filter, $prm, $category)
	{
		if($filter->type != 'compare') return;
		
		global $mainframe, $option;

		$itemid = JRequest::getInt('Itemid');
		$fparams = $filter->exec_params;
		$fid = $fparams->get('ext_filter_field');
		switch ($fparams->get('ext_filter_compare'))
		{
			case 1:
				$w = " < ".(int)$filter->default[0];
				break;
			case 2:
				$w = " > ".(int)$filter->default[0];
				break;
			case 3:
				$w = " <= ".(int)$filter->default[0];
				break;
			case 4:
				$w = " >= ".(int)$filter->default[0];
				break;
			case 5:
				$w = " = '{$filter->default[0]}'";
				break;
			case 'LIKE1':
				$w = " LIKE '{$filter->default[0]}%'";
				break;
			case 'LIKE2':
				$w = " LIKE '%{$filter->default[0]}'";
				break;
			case 'LIKE3':
				$w = " LIKE '%{$filter->default[0]}%'";
				break;
		}
		
		if($filter->default) $where[] = "r.id IN (SELECT record_id FROM #__js_res_record_values WHERE field_id = {$fid} AND field_value {$w})";
	}
	function onFilterLeftJoin(&$query, $filter, $params, $category)
	{}

	function onFilterWorn(&$out, $filter, $prm, $category)
	{
		if($filter->type != 'compare') return;
		//$str =  '%s %s %s - %s %s %s';
		//$fparams = $filter->exec_params;
		//$str = sprintf($str,  $fparams->get('ext_filter_text_1'), @$filter->default[0], $fparams->get('ext_filter_text_2'),
		//$fparams->get('ext_filter_text_3'), @$filter->default[1], $fparams->get('ext_filter_text_4'));

		$out = @$filter->default[0];
	}
	function onFilterRender(&$out, $filter, $category, $prm)
	{
		if($filter->type != 'compare') return;
		
		$patern = '%s %s %s';
		$fparams = $filter->exec_params;
		$fname_from = 'ext_filter'.$filter->id.'[]';
		$fname_to = 'ext_filter'.$filter->id.'[]';

		switch($fparams->get('ext_filter_type'))
		{
			case 1:
				$from = sprintf('<input type="text" name="%s" value="%s" size="%d" />', $fname_from, @$filter->default[0], $fparams->get('ext_filter_size'));
				break;
			case 2:
				$db = JFactory::getDBO();
				$where = "AND r.published = 1
					#AND c.published = 1
					AND (r.extime = '0000-00-00 00:00:00' OR r.extime > NOW())
					AND r.ctime <= NOW()
					AND r.client = 'resource'";

				switch ($prm->get('filters_mode', 1))
				{
					case 1:
						$sql = "SELECT fv.field_value AS value,
						CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text, COUNT(r.id) as total
						FROM #__js_res_record_values as fv
						LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
						LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
						WHERE fv.field_id = ".$fparams->get('ext_filter_field')."
						AND rc.catid = {$category} {$where}
						GROUP BY fv.field_value";
						break;
					case 3:
					case 2:
						$sql = "SELECT fv.field_value AS value,
						CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text, COUNT(r.id) as total
						FROM #__js_res_record_values as fv
						LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
						WHERE fv.field_id = ".$fparams->get('ext_filter_field')." {$where}
						GROUP BY fv.field_value";
						break;
				}

				if($fparams->get('ext_filter_sort')) $sql .= ' ORDER BY ' . $fparams->get('ext_filter_sort');

				$db->setQuery($sql);
				$get = $db->loadObjectList();

				// check if data stored as serializes array
				if($get)
				{
					$array = array();
					foreach ($get AS $option)
					{
						$add = @unserialize($option->value);
						if(is_array($add))
						{
							foreach($add AS $val)
							{
								$array[$val]->value = $val;
								$array[$val]->text = $val;
							}
						}
					}
					if(count($array) > 0) $get = $array;
				}


				$option1[] = JHTML::_('select.option', '', $fparams->get('ext_filter_text_3'));
				if($get) $option1 = array_merge($option1, $get);

				$from 	= JHTML::_('select.genericlist', $option1, $fname_from, 'class="inputbox"', 'value', 'text', @$filter->default[0]);
				break;
					
					case 3:

						$fromlist = explode("\n", $fparams->get('ext_filter_custom_1'));

						if(is_array($fromlist))
						{
							foreach ($fromlist AS $key => $option)
							{
								$from_list[$key]->value = $option;
								$from_list[$key]->text = $option;
							}
						}

						$option1[] = JHTML::_('select.option', '', $fparams->get('ext_filter_text_3'));
						if($from_list) $option1 = array_merge($option1, $from_list);

						$from 	= JHTML::_('select.genericlist', $option1, $fname_from, 'class="inputbox"', 'value', 'text', @$filter->default[0]);
						break;
		}

		$out = sprintf($patern, $fparams->get('ext_filter_text_1'), $from, $fparams->get('ext_filter_text_2'));
	}
}