<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

$document = &JFactory::getDocument();
$document->addScript( JURI::root().'media/mightyextensions/xajax/xajax_js/xajax_core.js' );

class plgJoomsuite_contentFilter_select_related extends JPlugin
{
	function plgJoomsuite_contentFilter_select_related( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onFilterWhere( &$where, $filter, $prm, $category )
	{
		if( $filter->type != 'select_related' ) return;

		global $mainframe, $option;

		if($filter->default)
		{
			$fparams = & $filter->exec_params;
	
		    if( $filter->exec_params->get( 'ext_filter_view' ) == 'select' ) {
	            $chains = array( implode( '\n', $this->prepareLines($filter->default)));
	        } else {
	        	$chains = $filter->default;
	        }
			
			settype($chains, 'array');
			$like = str_replace( array( "\n", "\r" ), array( '\n', '' ), implode('\n', $chains));
			$fid = $filter->exec_params->get( 'ext_filter_field' );
	        $where[] = "r.id IN (SELECT record_id FROM #__js_res_record_values WHERE field_id = {$fid} AND field_value LIKE '$like%')";
			/*foreach( $chains as $chain ) {
				$condition[] = $f_alias.' like "'.str_replace( array( "\n", "\r" ), array( '\n', '' ), $chain."\n" ).'%"';
			}*/
		}
	}

	function onFilterLeftJoin( &$query, $filter, $params, $category )
	{
		/*if($filter->type != 'select_related') return;

		$fparams = $filter->exec_params;

		if($filter->default) {
			$query .= " LEFT JOIN #__js_res_record_values AS ev".$fparams->get('ext_filter_field')." ON ev".$fparams->get('ext_filter_field').".record_id = r.id ";
			$query .= " LEFT JOIN #__js_res_fields AS ef".$fparams->get('ext_filter_field')." ON ef".$fparams->get('ext_filter_field').".id = ev".$fparams->get('ext_filter_field').".field_id ";
		}*/
	}

	function onFilterWorn( &$out, $filter, $prm, $category )
	{
		if( $filter->type != 'select_related' ) return;

		$db = JFactory::getDBO();
        
        $db->setQuery( "SELECT params FROM #__js_res_filters WHERE id = ".$filter->id );
        $filter_ini_params = $db->loadResult();

        $filter_params = new JParameter( $filter_ini_params );

        $db->setQuery( "SELECT params FROM #__js_res_fields WHERE id = ".$filter_params->get( 'ext_filter_field' ) );
        $field_ini_params = $db->loadResult();
         
        $params = new JParameter( $field_ini_params );
		
		$fragments = array();
		
	    if( $filter->exec_params->get( 'ext_filter_view' ) == 'select' ) {
            $chains = isset( $filter->default ) ? array( implode( "\n", $this->prepareLines( $filter->default ) ) ) : array();
        } else {
            $chains = isset( $filter->default ) ? $filter->default : array();
        }
        
        $dump_values = $this->parseValues( $params->get( "values" ) );
        
        foreach ( $chains as $chain ) {
		    $values = explode( "\n", $chain );
	
	        $res_values = array();
	        
	        $parent = null;
	        
	        foreach( $values as $key => $value ) {
	            $separator = ( $key > 0 ? " " : "" );
	            
	            $part_of_values = $this->getValuesByParent( $dump_values, $parent );
	            
	            $parent = $this->findNewParent( $part_of_values, $dump_values, $value );
	            
	            if( !isset( $dump_values[$parent] ) ) {
	                $res_values[] = $separator.$value;
	            } else {
		            if( $dump_values[$parent]["alt_value"] !== null && !( $key + 1 == count( $values ) && !trim( $dump_values[$parent]["alt_value"] ) ) ) {
	                    $res_values[] = $dump_values[$parent]["alt_value"];
	                } else {
	                    $res_values[] = $separator.$dump_values[$parent]["value"];
	                }
	            }
	        }

	        switch( $filter_params->get( 'worn_format' ) ) {
	            case "last_only" :
	                $fragments[] = $res_values[ count( $res_values ) - 1 ];
	                break;
	            default : 
	            case "all" :
	                $fragments[] = implode( "", $res_values );
	                break;
	        }
        }


        
		$out = "'".implode( "' ".$filter->exec_params->get('ext_filter_worn_separator')." '", $fragments )."'";
	}

	function onFilterRender( &$out, $filter, $category, $prm )
	{

		if($filter->type != 'select_related') return;
		
		if(!$filter->exec_params->get('ext_filter_field'))
		{
			JError::raiseWarning(100, JText::_('The field is not set in the extended filter "select relate"'));
			return;	
		}
		
		if( $filter->exec_params->get( 'ext_filter_view' ) == 'select' ) {
			$this->renderSelectView( $out, $filter, $category, $prm );
			return;
		}

		$db = JFactory::getDBO();

		$db->setQuery( "SELECT params FROM #__js_res_fields where id = ".$filter->exec_params->get( 'ext_filter_field' ) );
		$ini_params = $db->loadResult();
	  
		$params = new JParameter( $ini_params );
	  
		$filters_mode = $prm->get( 'filters_mode', 1 );
	  
		$exists_values = $this->getExistingsValues( $filters_mode, $filter->exec_params->get( 'ext_filter_field' ), $category );
	  
		$dump_values = $this->parseValues( str_replace( "\r", "", $params->get( "values" ) ) );
	  
		$selected_values = isset( $filter->default ) ? $filter->default : array() ;
	  
		foreach( $selected_values as $key => $selected_value ) {
			$selected_values[$key] = str_replace( "\r", "", $selected_value );
		}
	  
		$out = $this->renderThemAll( $dump_values, $selected_values, $filter->id, $exists_values );
	  
		$out .=  "<script type='text/javascript'>
	                function jsfilter".$filter->id."_expand( div_id, imgspan_id, value ) {
	                  var div = document.getElementById( div_id );
	                  div.innerHTML = '<img src=\"".JURI::root()."plugins/joomsuite_content/images/filter_select_related/loader.gif\" >';
	                  xajax_jsCallPlugin( 'joomsuite_content', 'filter_select_related', 'xajax_expandChild', [ ".$filter->id.", div_id, imgspan_id, value, ".$filters_mode.", ".$category." ] );
	                }
	                
	                function jsfilter".$filter->id."_collapse( div_id, imgspan_id, checkbox_id ) {
	                  var div = document.getElementById( div_id );
	                  var imgspan = document.getElementById( imgspan_id );
	                  
	                  div.innerHTML = '';
	                  
	                  var event = 'jsfilter".$filter->id."_expand( \''+div_id+'\', \''+imgspan_id+'\', document.getElementById( \''+checkbox_id+'\' ).value )';
	                  
	                  imgspan.innerHTML = '<img style=\"cursor: pointer;\" src=\"".JURI::root()."plugins/joomsuite_content/images/filter_select_related/collapsed.png\" onclick = \"'+event+'\" >';
	                } 
	              </script><div style='clear:both;'></div>";
	}

	function renderSelectView( &$out, $filter, $category, $prm )
	{
		$document = & JFactory::getDocument();
        $document->addStyleSheet( JURI::root().'plugins/joomsuite_content_fields/select_relate.css' );
		
		$db = JFactory::getDBO();

		$db->setQuery( "SELECT params FROM #__js_res_fields where id = ".$filter->exec_params->get( 'ext_filter_field' ) );
		$ini_params = $db->loadResult();

		$params = new JParameter( $ini_params );

		$filters_mode = $prm->get( 'filters_mode', 1 );

		$exists_values = $this->getExistingsValues( $filters_mode, $filter->exec_params->get( 'ext_filter_field' ), $category );

		$dump_values = $this->parseValues( str_replace( "\r", "", $params->get( "values" ) ) );

		$selected_values = isset( $filter->default ) ? $filter->default : array() ;

		foreach( $selected_values as $key => $selected_value ) {
			$selected_values[$key] = str_replace( "\r", "", $selected_value );
		}

		$out = '<div style="clear:both;"></div>'.$this->renderSelectsAll( $dump_values, $selected_values, $filter->id, $exists_values, $params );
		
		ob_start();
	    ?>
        <script type="text/javascript">
          function JSFexpandChild<?php echo $filter->id; ?>( parent, value, level )
          {
            var child_span = document.getElementById( 'sr_span_<?php echo $filter->id; ?>_' + ( level + 1 ) );

            child_span.innerHTML = "<img src='<?php echo JURI::root(); ?>/plugins/joomsuite_content_fields/images/select_relate/loader.gif'>";
          
            xajax_jsCallPlugin( 'joomsuite_content', 'filter_select_related', 'xajax_expandSelectChild', [ <?php echo $filter->id; ?>, parent, value, '<?php echo $filters_mode; ?>', '<?php echo $category; ?>' ] );
          }
        </script><div style='clear:both;'></div>
        <?php
        $out .= ob_get_contents();
        ob_end_clean();

	}

	function xajax_expandSelectChild( $objResponse, $filter_id, $super_parent, $value, $filters_mode, $category )
    {
        $super_parent = $super_parent === "null" ? null : (int)$super_parent;
         
        $db = JFactory::getDBO();
        
        $db->setQuery( "SELECT params FROM #__js_res_filters WHERE id = ".$filter_id );
        $filter_ini_params = $db->loadResult();

        $filter_params = new JParameter( $filter_ini_params );

        $db->setQuery( "SELECT params FROM #__js_res_fields WHERE id = ".$filter_params->get( 'ext_filter_field' ) );
        $field_ini_params = $db->loadResult();
         
        $params = new JParameter( $field_ini_params );
         
        $field_params = new JParameter( $field_ini_params );

        $exists_values = $this->getExistingsValues( $filters_mode, $filter_params->get( 'ext_filter_field' ), $category );
        
        $dump_values = $this->parseValues( $params->get( "values" ) );
         
        $parent_values = $this->getValuesByParent( $dump_values, $super_parent );
         
        $parent = $this->findNewParent( $parent_values, $dump_values, $value );
         
        $level_key = isset( $dump_values[ $super_parent ] ) ? ( $dump_values[ $super_parent ]["level"] + 2 ) : 2;
         
        $level_labels = $this->prepareLines( $params->get( "level_labels" ) );
        
        $html = "";
        
        if( $parent !== null ) {
            $new_values = $this->getValuesByParent( $dump_values, $parent );

            $event = "onchange=\"JSFexpandChild".$filter_id."( ".( is_null( $parent ) ? "'null'" : $parent ).", this.value, ".$level_key." );\"";
            
            if( count( $new_values ) ) {
                $options = $this->generateOptions( $new_values, $dump_values, $params->get( "sort" ), $exists_values );
                    
                $html = $this->renderList( $filter_id, $parent, $level_key, "", $options, $level_labels );

                $html .= '<span id="sr_span_'.$filter_id.'_'.( $level_key + 1 ).'"></span>';
            } 
        }

        $objResponse->assign( "sr_span_".$filter_id."_".$level_key, "innerHTML", $html );
    }
	
	
	function renderSelectsAll( $dump_values, $selected_values, $filter_id, &$exists_values, &$params )
	{
		$result = "";
		
		$level_labels = $this->prepareLines( $params->get( "level_labels" ) );
		
        $current_values = $selected_values;
        
        if( ! count( $current_values ) || ( $current_values[0] && $current_values[count( $current_values ) -1 ] ) ) {
            $current_values[] = "";
        }
        
        $parent = null;
        
        $opened_spans = 0;
        
        $key = 0;
        
        foreach( $current_values as $key_ => $current_value ) {

            $part_of_values = $this->getValuesByParent( $dump_values, $parent );
            
            if( !count( $part_of_values ) ) break;

            $options = $this->generateOptions( $part_of_values, $dump_values, $params->get( "sort" ), $exists_values );
            $result .= '<span id="sr_span_'.$filter_id.'_'.($key + 1).'">';

            $result .= $this->renderList( $filter_id, $parent, $key + 1, $current_value, $options, $level_labels );

            $parent = $this->findNewParent( $part_of_values, $dump_values, $current_value );

            $last_value = $current_value;

            $opened_spans ++;
            $key ++;
        }
        $key --;
        
        $result .= '<span id="sr_span_'.$filter_id.'_'.( $key + 2 ).'">';
        $result .= '</span>';

        $result .= str_repeat( "</span>", $opened_spans );
        
        return $result; 
	}
	
    function renderList( $filter_id, $parent, $level, $current_value, &$options, $level_labels )
    {
        $html = "";
        
        if( $level > 1 ) {
          $html.= '<span class="sr_arrow_img" style="background:url( '.JURI::root().'plugins/joomsuite_content_fields/images/select_relate/arrow.png ) no-repeat right 50%;"> '.( count( $level_labels ) ? "<br>" : "" ).'<span style="visibility:hidden">.</span> </span>';
        }
        
        $event = "onchange=\"JSFexpandChild".$filter_id."( ".( is_null( $parent ) ? "'null'" : $parent ).", this.value, ".$level." );\"";
        $html.= '<span class="sr_border">';
        if( count( $level_labels ) ) {
          $html.= ( isset( $level_labels[$level - 1] ) ? $level_labels[$level - 1] : "" ).'<br>';
        }
        
        $html.= '<span id="fields'.$filter_id.'_spanlist_'.$level.'">';
          $html.= JHTML::_('select.genericlist', $options, 'ext_filter'.$filter_id.'['.( $level - 1 ).']', 'class="inputbox" '.$event ,'value', 'text', htmlspecialchars( $current_value ), "fields".$filter_id."_".$level );
        $html.= '</span>';

        $html.= '</span>';

        return $html;
    }
	
    function generateOptions( & $values, & $dump_values, $sort_mode, & $exists_values ) {
        $result = array();
        $options_dump = array();
         
        foreach( $values as $value ) {
            $options_dump[$dump_values[$value]['value']] = $dump_values[$value]['value'];
            $chain_dump[$dump_values[$value]['value']] = $this->generateChain( $dump_values, $value );
        }
         
        if( $sort_mode == 2 ) ksort( $options_dump );
        if( $sort_mode == 3 ) krsort( $options_dump );

        $result[] = JHTML::_( 'select.option', "", "" );

        foreach( $options_dump as $value_option => $text_option ) {
            $result[] = JHTML::_( 'select.option', $value_option, $text_option.' ('.$this->recordsByValue( $exists_values, $chain_dump[$value_option] ).')' );
        }
        
        return $result;
    }
	
    function generateChain( & $dump_values, $index ) {
    	$result = "";
    	$separator = "";
    	while( $index !== null ) {
    	  $result = $dump_values[$index]['value'].$separator.$result;
    	  $separator = "\n";
    	  $index = $dump_values[$index]['parent'];
    	}
    	return $result; 
    }
    
	function getExistingsValues( $filters_mode, $filter_field_id, $category )
	{
		$db = JFactory::getDBO();

		$where = "AND r.published = 1
		         #AND c.published = 1
		         AND (r.extime = '0000-00-00 00:00:00' OR r.extime > NOW())
		         AND r.ctime <= NOW()
		         AND r.client = 'resource'";
	  
		switch ( $filters_mode ) {
			case 1:
				$sql = "    SELECT fv.field_value AS value, COUNT( r.id ) as total"
	                           
				."\n      FROM #__js_res_record_values   AS fv"
				."\n LEFT JOIN #__js_res_record          AS r  ON r.id = fv.record_id"
				."\n LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id"
	            
				."\n     WHERE fv.field_id = ".$filter_field_id."
	                           AND rc.catid = {$category} {$where}"
				 
				."\n  GROUP BY fv.field_value";
				break;
			case 2:
				$sql = "    SELECT fv.field_value AS value, COUNT( r.id ) as total"
	        
				."\n      FROM #__js_res_record_values AS fv"
				."\n LEFT JOIN #__js_res_record        AS r  ON r.id = fv.record_id"
	            
				."\n     WHERE fv.field_id = ".$filter_field_id." {$where}"
				 
				."\n  GROUP BY fv.field_value";
				break;
				
			// Current category and subcategories
			case 3:	
				$list = array();
				$list[] = $category;				
				$this->getSubCategories($category, $list);			
				$sql = "    SELECT fv.field_value AS value, COUNT( r.id ) as total"
	                           
				."\n      FROM #__js_res_record_values   AS fv"
				."\n LEFT JOIN #__js_res_record          AS r  ON r.id = fv.record_id"
				."\n LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id"
	            
				."\n     WHERE fv.field_id = ".$filter_field_id."
	                           AND rc.catid IN (".implode(',', $list).") {$where}"
				 
				."\n  GROUP BY fv.field_value";
				break;
		}

		$db->setQuery( $sql );
		$exists_values = $db->loadObjectList();

		return $exists_values;
	}

	// get children categories
	function getSubCategories($category, &$list)
	{
		$return = true;
		$db =& JFactory::getDBO();
		$sql = "SELECT id FROM #__js_res_category WHERE parent=".intval($category);
		$db->setQuery($sql);		
		$rows = $db->loadObjectList();
		
		//echo "<scipt>alert('FIK');</script";
		
		// check in list or not
		foreach($rows AS $row){
			$found = false;
			foreach($list as $idx){
				if ($idx == $row->id) {
					$found = true;
					break;
				}
			}
			if (!$found) {
				$list[] = $row->id;
			}
			$return = $this->getSubCategories($row->id, $list);
		}
		return $return;
	}
	
	function recordsByValue( $exist_values, $value )
	{
		$result = 0;
		if( count($exist_values) ){
			foreach( $exist_values as $exist_value ) {
				if( $value."\n" == JString::substr( $exist_value->value."\n", 0, JString::strlen( $value."\n"  ) ) ) {
					$result += $exist_value->total;
				}
			}
		}
		return $result;
	}

	function renderThemAll( $dump_values, $selected_values, $filter_id, $exists_values, $parent = null, $current_chain = "" )
	{
		$current_values = $this->getValuesByParent( $dump_values, $parent );

		$result = "";

		$lets_render = false;

		foreach( $current_values as $cvalue ) {
			if( $parent === null ) {
				$lets_render = true;
			} else {
				$current_sub_chain = $current_chain.( $current_chain ? "\n" : "" ).$dump_values[$cvalue]["value"];
				foreach( $selected_values as $chain ) {
					if( $current_sub_chain."\n" == JString::substr( $chain."\n", 0, JString::strlen( $current_sub_chain."\n"  ) ) ) {
						$lets_render = true;
						break;
					}
				}
			}
		}

		if( $lets_render ) {
				
			$div_container_id = "jsfilter".$filter_id."_cdiv".( $parent === null ? 'null' : $parent );
			$result .= "<div style='padding-left:25px;' id='".$div_container_id."'>";
				
			foreach( $current_values as $cvalue ) {

				$sub_result = "";
				$current_sub_chain = $current_chain.( $current_chain ? "\n" : "" ).$dump_values[$cvalue]["value"];

				if( $dump_values[$cvalue]["children"] ) {
					$sub_result = $this->renderThemAll( $dump_values, $selected_values, $filter_id, $exists_values, $cvalue, $current_sub_chain );
				}

				$div_sub_container_id = "jsfilter".$filter_id."_cdiv".$cvalue;
				$imgspan_id           = "jsfilter".$filter_id."_cimgspan".$cvalue;
				$checkbox_id          = "jsfilter".$filter_id."_ccheckbox".$cvalue;

				$result .= "<span style='padding-right:5px;' id='".$imgspan_id."'>";

				if( $sub_result ) {
					$event = "onclick='jsfilter".$filter_id."_collapse( \"".$div_sub_container_id."\", \"".$imgspan_id."\", \"".$checkbox_id."\" )'";
					$img_src = "src='".JURI::root()."plugins/joomsuite_content/images/filter_select_related/expanded.png'";
				} else if ( $dump_values[$cvalue]["children"] ) {
					$event = "onclick='jsfilter".$filter_id."_expand( \"".$div_sub_container_id."\", \"".$imgspan_id."\", document.getElementById( \"".$checkbox_id."\" ).value )'";
					$img_src = "src='".JURI::root()."plugins/joomsuite_content/images/filter_select_related/collapsed.png'";
				} else {
					$event = "";
					$img_src = "src='".JURI::root()."plugins/joomsuite_content/images/filter_select_related/empty.png'";
				}

				$result .= "<img ".$img_src." ".$event." style='cursor: pointer;'>";
				$result .= "</span>";

				if( in_array( $current_sub_chain, $selected_values ) ) {
					$cheked = "checked='checked'";
				} else {
					$cheked = "";
				}

				$result .= "<input type='checkbox' ".$cheked." name='ext_filter".$filter_id."[]'; id='".$checkbox_id."' value='".htmlspecialchars( $current_sub_chain, ENT_QUOTES )."'>";


				$result .= $dump_values[$cvalue]["value"].' ('.$this->recordsByValue( $exists_values, $current_sub_chain ).')';
				 
				if( $sub_result ) {
					$result .= $sub_result;
				} else {
					$result .= "<div style='padding-left:25px;' id='".$div_sub_container_id."'></div>";
				}
			}
				
			$result .= "</div>";
		}

		return $result;
	}

	function xajax_expandChild( $objResponse, $filter_id, $div_container_id, $parent_imgspan_id, $value_chain, $filters_mode, $category )
	{

		$db = JFactory::getDBO();

		$db->setQuery( "SELECT params FROM #__js_res_filters WHERE id = ".$filter_id );
		$filter_ini_params = $db->loadResult();

		$filter_params = new JParameter( $filter_ini_params );

		$db->setQuery( "SELECT params FROM #__js_res_fields WHERE id = ".$filter_params->get( 'ext_filter_field' ) );
		$field_ini_params = $db->loadResult();

		$field_params = new JParameter( $field_ini_params );

		$exists_values = $this->getExistingsValues( $filters_mode, $filter_params->get( 'ext_filter_field' ), $category );

		$dump_values = $this->parseValues( str_replace( "\r", "", $field_params->get( "values" ) ) );
		$value_chain = str_replace( "\r", "", $value_chain );

		$e_value_chain = explode( "\n", $value_chain );

		$parent = null;

		foreach( $e_value_chain as $value ) {
			$value_indexes = $this->getValuesByParent( $dump_values, $parent );
			$parent = $this->findNewParent( $value_indexes, $dump_values, $value );
		}

		$parent_checkbox_id  = "jsfilter".$filter_id."_ccheckbox".$parent;

		$value_indexes = $this->getValuesByParent( $dump_values, $parent );

		$result= "";

		foreach( $value_indexes as $cvalue ) {

			$current_sub_chain = $value_chain.( $value_chain ? "\n" : "" ).$dump_values[$cvalue]["value"];

			$div_sub_container_id = "jsfilter".$filter_id."_cdiv".$cvalue;
			$imgspan_id           = "jsfilter".$filter_id."_cimgspan".$cvalue;
			$checkbox_id          = "jsfilter".$filter_id."_ccheckbox".$cvalue;

			$result .= "<span style='padding-right:5px;' id='".$imgspan_id."'>";

			if ( $dump_values[$cvalue]["children"] ) {
				$event = "onclick='jsfilter".$filter_id."_expand( \"".$div_sub_container_id."\", \"".$imgspan_id."\", document.getElementById( \"jsfilter".$filter_id."_ccheckbox".$cvalue."\" ).value )'";
				$img_src = "src='".JURI::root()."plugins/joomsuite_content/images/filter_select_related/collapsed.png'";
			} else {
				$event = "";
				$img_src = "src='".JURI::root()."plugins/joomsuite_content/images/filter_select_related/empty.png'";
			}

			$result .= "<img ".$img_src." ".$event." style='cursor: pointer;' >";
			$result .= "</span>";

			$result .= "<input type='checkbox' name='ext_filter".$filter_id."[]'; id='".$checkbox_id."' value='".htmlspecialchars( $current_sub_chain, ENT_QUOTES, "UTF-8" )."'>";

			$result .= $dump_values[$cvalue]["value"].' ('.$this->recordsByValue( $exists_values, $current_sub_chain ).')';;

			$result .= "<div style='padding-left:25px;' id='".$div_sub_container_id."'></div>";
		}

		$objResponse->assign( $div_container_id, "innerHTML", $result );

		$objResponse->assign( $parent_imgspan_id, "innerHTML", "<img src='".JURI::root()."plugins/joomsuite_content/images/filter_select_related/expanded.png' style='cursor: pointer;' onclick='jsfilter".$filter_id."_collapse( \"".$div_container_id."\", \"".$parent_imgspan_id."\", \"".$parent_checkbox_id."\" )'>" );
	}

	function getValuesByParent( & $dump_values, $parent )
	{
		$result = array();

		foreach( $dump_values as $key => $value) {
			if( $value["parent"] === $parent ) {
				$result[] = $key;
			}
		}

		return $result;
	}

	function findNewParent( & $values, & $dump_values, $needle )
	{
		foreach ( $values as $value ) {
			if( $dump_values[$value]["value"] == $needle ) {
				return $value;
			}
		}
	}

    function parseValues( $param_values )
    {
        $v_lines = explode( "\n", $param_values );

        $result = array();
        $matches = array();
        $current_nesting = array( );


        foreach( $v_lines as $line_num => $line ) {
            $line = trim( $line );

            if( !$line ) continue;

            preg_match( "/^([> ]*)(\{([^\{\}]*)\})?(.*)$/", $line, $matches );
            
            $level_prefix = $matches[1];
            $alt_value = JString::strlen( $matches[3] ) < JString::strlen( $matches[2] ) ? $matches[3] : null;
            $value = $matches[4];

            $level = substr_count( $level_prefix, ">" ) + 1;

            $current_level = count( $current_nesting );

            if( $level - $current_level >= 2 ) {
                return false;
            }

            if( $level - $current_level == 1 ) {
                $current_nesting[] = count( $result );
            }

            if( $level == $current_level ) {
                $current_nesting[count( $current_nesting ) - 1] = count( $result );
            }

            if( $level < $current_level ) {
                if( $level == 1 ) {
                    $current_nesting = array( count( $result ) );
                } else {
                    $current_nesting = array_slice ( $current_nesting, 0, - ( count( $current_nesting ) - $level ) );
                }
                $current_nesting[count( $current_nesting ) - 1] = count( $result );
            }

            $parent = isset( $current_nesting[ count( $current_nesting ) - 2 ] ) ? $current_nesting[ count( $current_nesting ) - 2 ] : null;

            $result[] = array( "parent" => $parent, "level" => $level, "value" => $value, "children" => 0, 'alt_value' => $alt_value );

            if( $parent !== null ) {
                $result[$parent]["children"] ++;
            }
        }
        return $result;
    }
	
    function prepareLines( $text )
    {
        if( !is_array( $text ) ) {
          $lines = explode( "\n", $text );
        } else {
          $lines = $text;
        }
        
        $prepared_lines = array();
        
        foreach( $lines as $key => $v ) {
            if( !trim ( $v ) ) continue;
            $prepared_lines[] = $v;
        }
        
        return $prepared_lines;
    }
}